



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Cocos2d中使用颜色混合：加算，减算</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Cocos2d中使用颜色混合：加算，减算</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 15:10:49 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>转自http://blog.sina.com.cn/s/blog_7a2ffd5c0100xtid.html</p>
<p>CCSprite有一个ccBlendFunc类型的blendFunc_结构体成员，可以用来设置描绘时的颜色混合方案。ccBlendFunc包含了一个src和一个dst，分别表示目标和源的运算因子。</p>
<p>如果我们对一个Sprite使用setBlendFunc方法，如：</p>
<p>[Sprite setBlendFunc:(ccBlendFunc){GL_ONE,GL_ZERO} ];</p>
<p>会以这个Sprite作为源，Sprite所在位置的其它像素作为目标，进行混合运算:</p>
<p>源的RGBA变量：Rs，Gs，Bs，As；</p>
<p>目标的RGBA：&nbsp;&nbsp;Rd，Gd，Bd，Ad；</p>
<p>源的各个运算因子：&nbsp;&nbsp;N_Rs，N_Gs，N_Bs，N_As；</p>
<p>目标的各个运算因子：&nbsp;&nbsp;&nbsp;N_Rd，N_Gd，N_Bd，N_Ad；</p>
<p>混合后的RGBA为：(Rs*N_Rs+ Rd* N_Rd，Gs*N_Gs+ Gd* N_Gd，</p>
<p>Bs*N_Bs+ Bd* N_Bd，As*N_As+ Ad* N_Ad)</p>
<p>其中的运算因子包括：</p>
<p>GL_ONE：1.0</p>
<p>GL_ZERO：0.0</p>
<p>GL_SRC_ALPHA：源的Alpha值作为因子</p>
<p>GL_DST_ALPHA：目标Alpha作为因子</p>
<p>GL_ONE_MINUS_SRC_ALPHA：1.0减去源的Alpha值作为因子</p>
<p>GL_ ONE_MINUS_DST_ALPHA：1.0减去目标的Alpha值作为因子</p>
<p>我们可以在CCSprite的init方法中看到，默认的状态下使用GL_ONE,GL_ONE_MINUS_SRC_ALPHA这两个参数，这也是我们看到的情况，Sprite会覆盖下面的描绘，但如果有透明的地方，则会显示下面的色值。让我们看一下说使用各个参数的效果：</p>
<p>0：不改变混合，使用默认的情况：<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img referrerpolicy="no-referrer"src="http://s1.sinaimg.cn/middle/7a2ffd5cgb7bb9d53c3f0&amp;690" /></p>
<p>1：如果设置glBlendFunc(GL_ONE,GL_ZERO)，&nbsp;表面完全使用源颜色，即和不混合一样的效果，但是如果Sprite本身有透明的地方，则透明的地方会变成黑色。因为此时不显示目标的颜色。即使透明度为0也没有意义。<br /><img referrerpolicy="no-referrer"src="http://s14.sinaimg.cn/middle/7a2ffd5cgb7bb9d6d920d&amp;690" /></p>
<p>2：如果设置glBlendFunc(GL_ZERO, GL_ONE)，表示不使用源颜色，那么该Sprite便不被画出来。<br />&nbsp;&nbsp;<img referrerpolicy="no-referrer"src="http://s14.sinaimg.cn/middle/7a2ffd5cgb7bb9d73956d&amp;690" /></p>
<p>3：使用ALPHA相关的因子，会根据透明度来计算，比如透明度高的颜色占较大比重等。如默认情况。</p>
<p>附：</p>
<table>
<tbody>
<tr>
<td>常数</td>
<td>相关因子</td>
<td>融合因子结果</td>
</tr>
<tr>
<td>GL_ZERO</td>
<td>源因子或目的因子</td>
<td>(0,0,0,0)</td>
</tr>
<tr>
<td>GL_ONE</td>
<td>源因子或目的因子</td>
<td>(1,1,1,1)</td>
</tr>
<tr>
<td>GL_DST_COLOR</td>
<td>源因子</td>
<td>(Rd,Gd,Bd,Ad)</td>
</tr>
<tr>
<td>GL_SRC_COLOR</td>
<td>目的因子</td>
<td>(Rs,Gs,Bs,As)</td>
</tr>
<tr>
<td>GL_ONE_MINUS_DST_COLOR</td>
<td>源因子</td>
<td>(1,1,1,1)-(Rd,Gd,Bd,Ad)</td>
</tr>
<tr>
<td>GL_ONE_MINUS_SRC_COLOR</td>
<td>目的因子</td>
<td>(1,1,1,1)-(Rs,Gs,Bs,As)</td>
</tr>
<tr>
<td>GL_SRC_ALPHA</td>
<td>源因子或目的因子</td>
<td>(As,As,As,As)</td>
</tr>
<tr>
<td>GL_ONE_MINUS_SRC_ALPHA</td>
<td>源因子或目的因子</td>
<td>(1,1,1,1)-(As,As,As,As)</td>
</tr>
<tr>
<td>GL_DST_ALPHA</td>
<td>源因子或目的因子</td>
<td>(Ad,Ad,Ad,Ad)</td>
</tr>
<tr>
<td>GL_ONE_MINUS_DST_ALPHA</td>
<td>源因子或目的因子</td>
<td>(1,1,1,1)-(Ad,Ad,Ad,Ad)</td>
</tr>
<tr>
<td>GL_SRC_ALPHA_SATURATE</td>
<td>源因子</td>
<td>(f,f,f,1); f=min(As,1-Ad)</td>
</tr>
</tbody>
</table>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qn13kk8.html">PL&sol;SQL存储过程编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvov718.html">Oracle的DBMS&lowbar;OUTPUT&period;PUT&lowbar;LINE用法及脚本批处理方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqly6ze9.html">reqSUB错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k3013q.html">MyEclipse设置注释格式&lpar;转载&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zpx269.html">JPA 原生态SQL 的复杂查询之createNamedQuery</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjvrld9.html">java 调用oracle 分页存储过程 返回游标数据集</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zn03z9.html">HDU-2711                            Lost Cows</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnvew08.html">Java&lbrack;2&rsqb; 分布式服务架构之java远程调用技术浅析（转http&colon;&sol;&sol;www&period;uml&period;org&period;cn&sol;zjjs&sol;201208011&period;asp）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zydxn9.html">线段树菜鸟一题&plus;归并排序【求逆序数】POJ2299</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp2d139.html">JavaScript系统学习小结&mdash;&mdash;Object类型、Array类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yl7ew8.html">搜索引擎的缓存（cache）机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd03o49.html">Docker系列06&mdash;基于容器制作镜像并上传到Docker Registry</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r50524q.html">svn&colon;Item &amp;lsquo&semi;XXXXXX&amp;rsquo&semi; is out of date</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rw7j28.html">Service启动过程分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjl6lr9.html">vue中遇到的坑！！！！！</a>
		</li>
						<li><a href="https://www.batexi.com/a/q251lplq.html">笔记&colon;mysql升序排列asc，降序排列desc</a>
		</li>
						<li><a href="https://www.batexi.com/a/960w2on9.html">Fiddler（三）Fiddler 报错creation of the root certificate was not successful</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4py643q.html">【ARTS】01&lowbar;02&lowbar;左耳听风-20181119~1125</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1koje9.html">Windows下OpenCV 3&period;1&period;0 在 Qt Creator 4&period;0&period;2 &lpar;Qt 5&period;7&period;0 MinGW&rpar; 中的开发环境配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2knlovq.html">jenkins 执行ssh 远程linux执行命令</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/xq4ovnj8.html">LeetCode OJ-- Word Ladder II &ast;&ast;&ast;&commat;</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvylv1q.html">MongoDB 3&period;2 在windows上的安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2z4olq.html">（light OJ  1005） Rooks  dp</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kexv58.html">VS2013&lowbar;QT255开发相关技巧理解心得</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q756319.html">使用lock和condition实现的阻塞队列-字符串</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2zozvq.html">log4j使用方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kewp38.html">EJDB 1&period;1&period;18 发布，嵌入式JSON数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2zr2xq.html">MVC中使用RazorPDF创建PDF</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p4zz79.html">sqlhelper sqlparameter 实现增删改查</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwg7yz8.html">Try&period;&period;Finally&period;&period;相信自己的眼睛</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
